(贪心) LeetCode 376. 摆动序列

原题链接

一. 题目描述

如果连续数字之间的差严格地在正数和负数之间交替,则数字序列称为 摆动序列 。第一个差(如果存在的话)可能是正数或负数。仅有一个元素或者含两个不等元素的序列也视作摆动序列。

例如, 1, 7, 4, 9, 2, 5 是一个 摆动序列 ,因为差值 (6, -3, 5, -7, 3) 是正负交替出现的。

相反,1, 4, 7, 2, 5 和 1, 7, 4, 5, 5 不是摆动序列,第一个序列是因为它的前两个差值都是正数,第二个序列是因为它的最后一个差值为零。

子序列 可以通过从原始序列中删除一些(也可以不删除)元素来获得,剩下的元素保持其原始顺序。

给你一个整数数组 nums ,返回 nums 中作为 摆动序列 的 最长子序列的长度 。

示例 1:

输入:nums = 1,7,4,9,2,5

输出:6

解释:整个序列均为摆动序列,各元素之间的差值为 (6, -3, 5, -7, 3) 。

示例 2:

输入:nums = 1,17,5,10,13,15,10,5,16,8

输出:7

解释:这个序列包含几个长度为 7 摆动序列。

其中一个是 1, 17, 10, 13, 10, 16, 8 ,各元素之间的差值为 (16, -7, 3, -3, 6, -8) 。

示例 3:

输入:nums = 1,2,3,4,5,6,7,8,9

输出:2

提示:

1 <= nums.length <= 1000

0 <= numsi <= 1000

进阶:你能否用 O(n) 时间复杂度完成此题?

二. 解题思路

这个题目的意思就是让我们寻找最长的摆动序列,连续数字之间的差严格地在正数和负数之间交替,则数字序列称为 摆动序列。如果之间有数字不构成摆动序列,那么就可以删除一些元素从而让序列摆动。

题意很简单,但是做起来不知道怎么写?你难道真的准备判断是否摆动,然后遇到不是摆动序列的元素删除它吗?不不不,跳过不就好了,题目没有明确要求必须删除元素,我们只需要跳过该元素判断后面的元素是否摆动即可,最后只需要输出摆动序列的最长长度即可。

在计算是否有峰值的时候,大家知道遍历的下标 i ,计算 prediff(numsi - numsi-1) 和 curdiff(numsi+1 - numsi),如果prediff < 0 && curdiff > 0 或者 prediff > 0 && curdiff < 0 此时就有波动就需要统计。

下面可以将情况分为三种:

1. 上下坡中存在平坡:

像这种类型的我们只需要从左到右或者从右到左删除三个2就可以构成摆动序列了(如下图所示):

如果我们采用,删左面三个 2 的规则,那么 当 predif = 0 && curdif < 0 也要记录一个峰值,因为他是把之前相同的元素都删掉留下的峰值。

所以我们记录峰值的条件应该是: (predif <= 0 && curdif > 0) || (predif >= 0 && curdif < 0),为什么这里允许 prediff == 0 ,就是为了 上面的这种情况。
2. 数组的首尾两端:

大家可以发现,我们在上面计算predif 和curdif 的时候至少需要三个元素才能完成计算,那要是序列中只有两个元素呢?如1, 2,题目中明确要求,如果两个元素,存在两个摆动。那我们怎么将这种情况算到上面的哦按段条件中呢?

很简单,只需要给序列的首元素添加一个平坡即可(如下图所示),将序列2, 5 变为 2, 2, 5:

这样也就对 predif 就可以计算为 0 ,那末尾怎么算呢?其实我们末尾默认是有一个峰值的,所以我们将结果集 res 默认为 1 即可。这样就可以得到最后的 res 为2。

这样我们就可以得到一个代码:

cpp 复制代码
class Solution {
public:
    int wiggleMaxLength(vector<int>& nums) {
        if (nums.size() <= 1) return nums.size();
        int curDiff = 0; // 当前一对差值
        int preDiff = 0; // 前一对差值
        int result = 1;  // 记录峰值个数,序列默认序列最右边有一个峰值
        for (int i = 0; i < nums.size() - 1; i++) {
            curDiff = nums[i + 1] - nums[i];
            // 出现峰值
            if ((preDiff <= 0 && curDiff > 0) || (preDiff >= 0 && curDiff < 0)) {
                result++;
            }
            preDiff = curDiff;
        }
        return result;
    }
};

3. 单调坡度有平坡:

什么叫单调坡度有平坡呢,看下图就可以明白了:

从上图中大家觉得答案是多少, 应该是2,但是我们如果按照上面的代码计算方法会算出来3 ,显然是不对的,为什么呢,原因就是我们每一次都会将curdif 赋值给 predif ,但是遇到这种情况的平坡的时候,在最后一个2 处 predif = 0,然后后面计算的 curdif = 1。满足上面的判断条件,就会多加一次,实际上这里不存在摆动,这也就是我们代码中的一个逻辑性的错误。

对于解决上面的错误方法很简单,只需要将 predif = curdif 这个赋值代码加入到判断条件内部即可,保证摆动的前提是相较于上一次的摆动,而不是最近区间的摆动,这样prediff 在 单调区间有平坡的时候 就不会发生变化,从而避免误判。

话不多说!!!上代码!!

三. 代码

cpp 复制代码
class Solution {
public:
    int wiggleMaxLength(vector<int>& nums) {
        int res = 1;
        int predif = 0;
        int curdif = 0;
        int n = nums.size();
        for(int i = 0; i < n - 1; i++){
            curdif = nums[i + 1] - nums[i];
            if((predif >= 0 && curdif < 0) || (predif <= 0 && curdif > 0)){
                res++;
                predif = curdif;
            }
        }
        return res;
    }
};

四. 总结

这个题目还是比较绕的,需要考虑很多种情况,我感觉是比较难的一道题目,刚开始做的时候确实有点难懂,但是大家一定要多去看,多去理解,在本子上列举情况去分析,这样才能有进步,加油!!!。

时间复杂度:O(n);

空间复杂度:O(1)。

喜欢的话给个关注吧!!

相关推荐
fpcc3 小时前
c++编程实践—堆和栈越界调试
c++
yi0113 小时前
LeetCode 219:存在重复元素 II——哈希表记录“最近一次出现的位置”
数据结构·人工智能·笔记·python·算法·leetcode·哈希表
YangYang9YangYan4 小时前
2027 秋招|数据科学与大数据技术面试项目价值回答思路,告别纯代码描述
大数据·面试·职场和发展
weiabc4 小时前
MSYS2 UCRT64 + g++ C++ 中文输出乱码 完整全过程
c++
灯澜忆梦6 小时前
【面向对象编程C++】| 基础语法
java·c++·算法
禾小西6 小时前
Redis 数据结构:快速的 Redis 有哪些慢操作?
数据结构·数据库·redis
小蒋观天下6 小时前
专项方案:大场景港口AI安防、多干扰环境下的算法调优与落地实操
人工智能·深度学习·算法·安全·机器学习·计算机视觉·ai大模型
Evand J6 小时前
【电机滤波例程5】渐消因子自适应扩展卡尔曼滤波(EKF),MATLAB。PMSM负载突变下的状态估计。附下载链接
算法·matlab
H.莓飛6 小时前
【数据结构】二叉树_OJ题
linux·开发语言·数据结构·算法
好想像大佬一样能够ak所有7 小时前
Leetcode35.搜索插入位置
数据结构·算法·leetcode